<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;

class Frame extends Model
{
	protected static function boot() {
		parent::boot();

		static::addGlobalScope('order', function (Builder $builder) {
			$builder->orderBy('created_at','DESC');
		});
	}

	/**
	 * Return the Page Number
	 *
	 * @return string
	 */
	public function getPageAttribute()
	{
		return $this->frame.$this->index;
	}

	/**
	 * Fetch a specific frame from the database
	 *
	 * @param int $page
	 * @param string $frame
	 * @return mixed
	 */
	public function fetch(int $frame,string $index='a'): \App\Classes\Frame
	{
		// Return our internal test frame.
		if ($frame == '999' and $index == 'a')
			return new \App\Classes\Frame(\App\Classes\Frame::testFrame());

		return new \App\Classes\Frame($this->where('frame',$frame)->where('index',$index)->firstOrFail());
	}

	public function hasFlag(string $flag)
	{
		// @todo When flags is in the DB update this.
		return isset($this->flags) ? in_array($flag,$this->flags,FALSE) : FALSE;
	}

	/**
	 * Frame Types
	 */
	public function type()
	{
		return $this->type ?: 'i';
	}
}